unit RF60XUnitTypes;

//{$mode objfpc}{$H+}

interface

type
  P_rf60x_uart_stream_measure_t = ^rf60x_uart_stream_measure_t;

  rf60x_uart_stream_measure_t = record
    measure: word;
    status: byte;
    reserved: byte;
  end;

type
  P_rf60x_uart_result_with_encoder_t = ^rf60x_uart_result_with_encoder_t;

  rf60x_uart_result_with_encoder_t = record
    Value: word;
    rotationMarks: word;
    encoderValue: word;
  end;

type
  P_rf60x_udp_value_t = ^rf60x_udp_value_t;

  rf60x_udp_value_t = record
    Value: word;
    status: byte;
  end;

type
  P_rf60x_udp_measure_t = ^rf60x_udp_measure_t;

  rf60x_udp_measure_t = record
    rf60xValArray: array [0..167] of rf60x_udp_value_t;
    deviceSerial: word;
    deviceBaseDistance: word;
    deviceMeasureRange: word;
    packCount: byte;
    packetControlSumm: byte;
  end;

type
  P_rf60xB_udp_value_t = ^rf60xB_udp_value_t;

  rf60xB_udp_value_t = record
    measure: word;
    exposition: word;
    status: byte;
  end;

type
  P_rf60xB_udp_measure_t = ^rf60xB_udp_measure_t;

  rf60xB_udp_measure_t = record
    rf60xBValArray: array [0..100] of rf60xB_udp_value_t;
    reserved: word;
    reserved2: word;
    deviceSerial: word;
    deviceBaseDistance: word;
    deviceMeasureRange: word;
    packCount: byte;
    packetControlSumm: byte;

  end;

type
  P_rf60x_uart_hello_t = ^rf60x_uart_hello_t;

  rf60x_uart_hello_t = record
    deviceType: byte;
    deviceModificaton: byte;
    deviceSerial: word;
    deviceMaxDistance: word;
    deviceRange: word;

  end;

type
  P_rf60x_modbus_rtu_command = ^rf60x_modbus_rtu_command;

  rf60x_modbus_rtu_command = record
    id: byte;
    command: byte;
    address: word;
    Count: word;
    crc: word;
  end;


type
  TScanner_types = (kRF60x = 1, kRF60xHS = 2, kRF60xB = 3);

type
  TProtocol_types = (kRIFTEK_BIN_PROTOCOL = 1, kASCII = 2, kMODBUS_RTU = 3);


type
  TBAUR_RATE_UART = (Baud9600 = $04, Baud115200 = $30,
    Baud230400 = $60, Baud460800 = $C0, Baud921600 = $180);


type
  P_config_base_information_rf60x_t = ^config_base_information_rf60x_t;

  config_base_information_rf60x_t = record
    SCANNER_TYPE: TScanner_types;
    BAUR_RATE_UART: TBAUR_RATE_UART;
    network_address: byte;
    number_serial_port: string;
    protocol: TProtocol_types;
    recv_ip_addrs: PAnsiChar;
  end;


type

  r60x = record

  end;

// library initialization, must be called once before using
function init(): boolean; cdecl; external 'rf60Xsdk_c' Name 'init';
// library deinitialization, must be called at the end of program
procedure cleanup(); cdecl; external 'rf60Xsdk_c' Name 'cleanup';

function version(): integer; cdecl; external 'rf60Xsdk_c' Name 'version';

function connect(rf60x: THandle): boolean; cdecl; external 'rf60Xsdk_c' Name 'connect';

function disconnect(rf60x: THandle): boolean;
  cdecl; external 'rf60Xsdk_c' Name 'disconnect';

function get_measure_udp(rf60x: THandle; measure: Pointer): boolean;
  cdecl; external 'rf60Xsdk_c' Name 'get_measure_udp';

function create_rf60x(var config: config_base_information_rf60x_t): THandle;
  cdecl; external 'rf60Xsdk_c' Name 'create_rf60x';

function open_port_uart(rf60x: THandle): boolean;
  cdecl; external 'rf60Xsdk_c' Name 'open_port_uart';

function hello_msg_uart(rf60x: THandle): rf60x_uart_hello_t; cdecl;
  external 'rf60Xsdk_c' Name 'hello_msg_uart';

procedure change_config_port_uart(rf60x: THandle); cdecl;
  external 'rf60Xsdk_c' Name 'change_config_port_uart';

procedure close_port_uart(rf60x: THandle); cdecl;
  external 'rf60Xsdk_c' Name 'close_port_uart';




implementation

end.
